# PhasicFlow: pFlow::mapperNBSKernels Namespace Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

pFlow::mapperNBSKernels Namespace Reference

## Functions

void | findPointExtends (const deviceViewType1D< realx3 > &points, const pFlagTypeDevice &flags, realx3 &minPoint, realx3 &maxPoint)
bool | buildListsReduce (const cells &searchCell, const deviceViewType3D< uint32 > &head, const deviceViewType1D< uint32 > &next, const deviceViewType1D< realx3 > &points, const pFlagTypeDevice &flags)
bool | buildLists (const cells &searchCell, const deviceViewType3D< uint32 > &head, const deviceViewType1D< uint32 > &next, const deviceViewType1D< realx3 > &points, const pFlagTypeDevice &flags)

## Function Documentation

## findPointExtends()

void findPointExtends | ( | const deviceViewType1D< realx3 > & | points,
|  | const pFlagTypeDevice & | flags,
|  | realx3 & | minPoint,
|  | realx3 & | maxPoint
| ) |  |

Definition at line 27 of file mapperNBSKernels.cpp.

References pointFlag< ExecutionSpace >::activeRange(), LAMBDA_HD, pFlow::algorithms::KOKKOS::max(), pFlow::algorithms::KOKKOS::min(), and pointFlag< ExecutionSpace >::numActive().

Referenced by mapperNBS::setSearchBox().

Here is the call graph for this function:
Here is the caller graph for this function:

## buildListsReduce()

bool buildListsReduce | ( | const cells & | searchCell,
|  | const deviceViewType3D< uint32 > & | head,
|  | const deviceViewType1D< uint32 > & | next,
|  | const deviceViewType1D< realx3 > & | points,
|  | const pFlagTypeDevice & | flags
| ) |  |

Definition at line 85 of file mapperNBSKernels.cpp.

References pointFlag< ExecutionSpace >::activeRange(), pointFlag< ExecutionSpace >::isAllActive(), LAMBDA_HD, and cells::pointIndexInDomain().

Referenced by mapperNBS::build().

Here is the call graph for this function:
Here is the caller graph for this function:

## buildLists()

bool buildLists | ( | const cells & | searchCell,
|  | const deviceViewType3D< uint32 > & | head,
|  | const deviceViewType1D< uint32 > & | next,
|  | const deviceViewType1D< realx3 > & | points,
|  | const pFlagTypeDevice & | flags
| ) |  |

Definition at line 148 of file mapperNBSKernels.cpp.

References pointFlag< ExecutionSpace >::activeRange(), pointFlag< ExecutionSpace >::isAllActive(), LAMBDA_HD, and cells::pointIndex().

Referenced by mapperNBS::build().

Here is the call graph for this function:
Here is the caller graph for this function: